# uncomment the next line to add byteman to your env
#echo "JAVA_OPTS=\"$JAVA_OPTS -javaagent:/opt/byteman/lib/byteman.jar=script:/opt/byteman/scripts/TraceManager.btm,sys:/opt/byteman/lib/byteman.jar\""

# adding configuration
echo "Configuring seed instance..."
cp reproducer-standalone-ha.xml standalone/configuration/standalone-ha.xml

echo "Duplicating seed instance..."
cp counter.war standalone/deployments/
cp -a standalone standalone2
cp -a standalone standalone3

echo "Auto starting your cluster..."
gnome-terminal -e 'bin/standalone.sh -Djboss.jvmRoute=1 -Djboss.socket.binding.port-offset=0 -Djboss.node.name=1 -Djboss.server.base.dir=standalone -c standalone-ha.xml -b node1' --title="node1"
# sleep to let a node be master
sleep 5
gnome-terminal -e 'bin/standalone.sh -Djboss.jvmRoute=2 -Djboss.socket.binding.port-offset=100 -Djboss.node.name=2 -Djboss.server.base.dir=standalone2 -c standalone-ha.xml -b node2' --title="node2"
gnome-terminal -e 'bin/standalone.sh -Djboss.jvmRoute=3 -Djboss.socket.binding.port-offset=200 -Djboss.node.name=3 -Djboss.server.base.dir=standalone3 -c standalone-ha.xml -b node3' --title="node3"

# sleep to make sure both nodes are up
sleep 10
echo

# make a request to node1 to get a node1 cookie, then blast the load balancer with the cookie so that the other 
# two nodes contend for the lock
echo "Reproduce the locking issue with the following:"
n1_cookie=`curl -is http://node1:8080/counter/ | egrep -o 'Set-Cookie:(.*);' | egrep -o JSESSIONID=.*\.[0-9]`
echo "ab -C \"$n1_cookie\" -c 150 -n 10000 http://httpd-lb-host/counter/"
